#ifndef BRAIN_H
#define BRAIN_H

#include <stdint.h>
#include <sys/time.h>
#include "Eyes.h"

class Brain
{
public:
  Brain(int width, int height);
  ~Brain();
  void process(uint8_t *buffer);
  uint8_t *get_video_buffer() { return video_buffer; };
  uint8_t *get_diff_buffer() { return diff_buffer; };

private:
  bool can_eyes_change_dir();   // has enough time passed to change eye dir
  uint8_t *video_buffer;        // Previous Y buffer stored in just G of RGB
  uint8_t *diff_buffer;         // What the brain is seeing (RGB)
  Eyes *eyes;
  int inactivity_time;          // amount of time the eyes haven't moved
  int width, height;            // width,height of display area
  int eye_position;             // current eye position
  int eye_direction;            // direction the eyes are moving in
  struct timeval eye_move_time; // timestamp of last eye dir change
};

#endif

