#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdint.h>
#include <time.h>
#include <termios.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include "Eyes.h"

#define DEVICE "/dev/ttyUSB0"

Eyes::Eyes() : curr_value(-1)
{
  printf("Opening %s\n", DEVICE);

  fd = open(DEVICE, O_RDWR|O_NOCTTY);
  if (fd == -1)
  {
    printf("Couldn't open serial device.\n");
  }
    else
  {
    tcgetattr(fd, &oldtio);

    memset(&newtio, 0, sizeof(struct termios));
    newtio.c_cflag = B9600|CS8|CLOCAL|CREAD;
    newtio.c_iflag = IGNPAR;
    newtio.c_oflag = 0;
    newtio.c_lflag = 0;
    newtio.c_cc[VTIME] = 0;
    newtio.c_cc[VMIN] = 1;

    tcflush(fd, TCIFLUSH);
    tcsetattr(fd, TCSANOW, &newtio);
  }
}

void Eyes::turn(int value)
{
uint8_t c;

  //printf("turn %d\n", value);
  if (fd == 0) { return; }

  //value = 20 - value;

  c = (value << 3);
  write(fd, &c, 1);
  c = c | 3;
  write(fd, &c, 1);

  curr_value = value;
}

Eyes::~Eyes()
{
  if (fd == 0) { return; }

  tcsetattr(fd, TCSANOW, &oldtio);
  close(fd);
}


