#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <errno.h>
#include <string.h>
#include <sys/mman.h>
#include <asm/types.h>
#include <linux/videodev2.h>
#include <sys/ioctl.h>
#include <FL/Fl_Button.H>
#include <FL/Fl_Widget.H>
#include <FL/Fl_Window.H>
//#include <FL/run.h>

#include "Brain.h"
#include "Capture.h"
#include "VideoWindow.h"

#if 0
void motion_button_callback(Fl_Widget *w, void *data)
{
}

void image_button_callback(Fl_Widget *w, void *data)
{
}
#endif

int main(int argc, char *argv[])
{
  Brain *brain = new Brain(640, 480);
  Capture *capture = new Capture(640, 480);
  VideoWindow *window = new VideoWindow(800, 480, brain->get_diff_buffer());
  window->begin();

#if 0
  Fl_Button motion_button(655,250,130,40, "Show Motion");
  Fl_Button image_button(655,300,130,40, "Show Image");

  motion_button.callback(motion_button_callback, window);
  image_button.callback(image_button_callback, NULL);
#endif

  window->end();
  window->show(argc, argv);

  capture->init();

  while(1)
  {
    Fl::wait(0.03);

    capture->read_frame();
    brain->process(capture->get_image());
    window->redraw();
  }

  return 0;
}


